<?php

defined('JPATH_PLATFORM') or die;


use JTFramework\JTlicense;
use JTFramework\JTfunc;
use JTFramework\JTdebug;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Version;
use JTFramework\Fa5;

if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php'))
{
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
}else{
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}



class JFormFieldJtcheck extends JFormFieldText
{
    protected $type = 'jtcheck';


    protected function getLabel(){
        $mode = $this->element['mode'];
        if($mode == 'dashboard'){
            return;
        }
    }

    protected function getInput()
    {

        Fa5::getFaCDN();
        $lang = Factory::getLanguage();
        $lang->load('plg_system_jtframework', JPATH_PLUGINS . '/system/jtframework');


        $field_set = $this->form->getFieldset();
        $params = $this->form->getValue('params');

        $valida = JTlicense::_checkLicense();

        //var_dump($valida);

        $field_value = '';

        if($valida) $field_value .= $this->pro();
        if(!$valida) $field_value .= $this->lite();

        return $field_value;
    }




    private function lite(){

        JTlicense::disableFormsv3();

        $module_id = $this->form->getValue('id');
        $params = $this->form->getValue('params');

        if($params !== NULL){
            //$this->form->setValue('pfeedcomments','0');
            $params->generate_thumbs = '0';
            $params->force_itemid = '0';
            $params->cat_itemid_based = '0';
            $params->category_as_item = '0';
            $params->show_front = 'show';
            $params->mode = 'manual';
        }else{
            return $this->mensajeLITE();
        }

        $params->jtotal_license_check = 0;

        //consulta
        $reparams = $this->form->getValue('params');

        $encode_params = json_encode($reparams);

        $db = Factory::getDBO();
        $query = $db->getQuery(true);
        // Build the query
        $query->update('#__modules AS a');
        $query->set('a.params = ' . $db->quote((string)$encode_params));
        $query->where('a.id = '.$module_id);

        // Execute the query
        $db->setQuery($query);
        
        // Execute the query
        $db->setQuery($query);
        
        $jversion = new Version();
        if($jversion->getShortVersion() >= "3.0"){
            //v3
            $db->query();
        }else{
            //v4
            $db->execute();
        }


        return $this->mensajeLITE();


    }

    private function pro(){

             
            $field_value='';

            return $field_value;

    }

    private function mensajeLITE(){
        return '<div class="alert alert-info">'.Text::_('JT_FW_EXTENSIONS_SOME_VALUES_LITE').'</div>';
    }


}
