<?php
/**
* @Copyright Copyright (C) 2021 jtotal.org All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* @link     	https://jtotal.org
**/
// no direct access
defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Helper\ModuleHelper;
use Joomla\CMS\Profiler\Profiler;
use Joomla\CMS\Uri\Uri;

$debug = $params->get('visual_menu_debug', 0);
if($debug){
	$profiler = new Profiler();
}

$document = Factory::getDocument();	

$show_readmore = $params->get('show_readmore', 0);
$show_readmore_target = $params->get('show_readmore_target', '_self');
$readmore_class = $params->get('readmore_class', 'btn btn-success');

$img_position = $params->get('img_position', 'top');

$jinput = Factory::getApplication()->input;
//helper
JLoader::register('ModVisualMenuHelper', __DIR__ . '/helper.php');

//normal or automatic mode
$mode = $params->get('mode', 'normal');
$idbase = null;
switch($mode){
	case 'automatic':
		$option = $jinput->get('option', '', 'WORD');
		$view = $jinput->get('view', '', 'WORD');
		if ($option === 'com_content') {
			switch($view){
				case 'category':
					$idbase = $jinput->get('id', '', 'INT');
					break;
				case 'categories':
					$idbase = $jinput->get('id', '', 'INT');
					break;
				case 'article':
					
						$idbase =  $jinput->get('id', '', 'INT');
					
				break;
			}
		}
		break;
	case 'normal':
	case 'api':
		$idbase = $module->id;
	default:
		$idbase = $params->get('catid');
		break;
}


if($mode == 'api'){
	
	$cacheid = md5(serialize(array ($idbase,$module->module)));

	$cacheparams = new stdClass;
	$cacheparams->cachemode = 'id';
	$cacheparams->class = 'ModVisualMenuHelper';
	$cacheparams->method = 'getApiList';
	$cacheparams->methodparams = $params;
	$cacheparams->modeparams = $cacheid;
	
	$list = ModuleHelper::moduleCache ($module, $params, $cacheparams);
}else{
	$cacheid = md5(serialize(array ($idbase,$module->module)));
	$cacheparams = new stdClass;
	$cacheparams->cachemode = 'id';
	$cacheparams->class = 'ModVisualMenuHelper';
	$cacheparams->method = 'getList';
	$cacheparams->methodparams = $params;
	$cacheparams->modeparams = $cacheid;

	$list = ModuleHelper::moduleCache ($module, $params, $cacheparams);
}



$vm_titles_h = $params->get('vm_titles_h', '5');

$use_article_url = $params->get('use_article_url', 0);


//var_dump($list);



//return;
//$list = "lala";

if (!empty($list)) {
	$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));
	$item_heading = $params->get('item_heading');
	


	//BASE STYLE

	if($params->get('base_css',1)){
		
		if($params->get('load_css_async',0)){
			ModVisualMenuHelper::addDebug("LOAD BASE STYLE",'visual_menu_base ASYNC');
			echo '<noscript id="deferred-styles_visualmenu"><link rel="stylesheet" type="text/css" href="'.URI::root().'media/mod_visual_menu/css/visual_menu_base.css"/>
			</noscript>';
	
			echo '<script>
				var loadDeferredStyles_visualmenu = function() {
				var addStylesNode = document.getElementById("deferred-styles_visualmenu");
				var replacement = document.createElement("div");
				replacement.innerHTML = addStylesNode.textContent;
				document.body.appendChild(replacement)
				addStylesNode.parentElement.removeChild(addStylesNode);
				};
				var raf = requestAnimationFrame || mozRequestAnimationFrame ||
					webkitRequestAnimationFrame || msRequestAnimationFrame;
				if (raf) raf(function() { window.setTimeout(loadDeferredStyles_visualmenu, 0); });
				else window.addEventListener(\'load\', loadDeferredStyles_visualmenu);
			</script>';

		}else{
			ModVisualMenuHelper::addDebug("LOAD BASE STYLE",'visual_menu_base PLAIN');
			$document->addStyleSheet(URI::root().'media/mod_visual_menu/css/visual_menu_base.css');
		}
	}



	//CSS STYLE

	$style = $params->get('style_css','');



	if($style !=''){
		
		if($params->get('load_css_async',0)){
			ModVisualMenuHelper::addDebug("LOAD CUSTOM STYLE",$style.' ASYNC');
			echo '<noscript id="deferred-styles_visualmenu_style"><link rel="stylesheet" type="text/css" href="'.URI::root().'media/mod_visual_menu/styles/'.$style.'.css"/>
			</noscript>';
	
			echo '<script>
				var loadDeferredStyles_visualmenu_style = function() {
				var addStylesNode = document.getElementById("deferred-styles_visualmenu_style");
				var replacement = document.createElement("div");
				replacement.innerHTML = addStylesNode.textContent;
				document.body.appendChild(replacement)
				addStylesNode.parentElement.removeChild(addStylesNode);
				};
				var raf = requestAnimationFrame || mozRequestAnimationFrame ||
					webkitRequestAnimationFrame || msRequestAnimationFrame;
				if (raf) raf(function() { window.setTimeout(loadDeferredStyles_visualmenu_style, 0); });
				else window.addEventListener(\'load\', loadDeferredStyles_visualmenu_style);
			</script>';

		}else{
			ModVisualMenuHelper::addDebug("LOAD CUSTOM STYLE",$style.' PLAIN');
			$document->addStyleSheet(URI::root().'media/mod_visual_menu/styles/'.$style.'.css');
		}
	}




	//$document->addStyleSheet(JURI::root().'modules/mod_visual_menu/css/vm_bs4.css');

	$layout = $params->get('layout', 'default');

	require ModuleHelper::getLayoutPath('mod_visual_menu', $layout);
}



if($debug){

	$html ='';

	$msgs = ModVisualMenuHelper::getDebug();

	
	if($params->get('cache',0)){

		$config = Factory::getConfig();
		$global_cache = $config->get('caching');

		if($global_cache){
			$html .=  $profiler->mark( ' with caching' );
		}else{
			$html .=  $profiler->mark( ' with caching in module, but disabled in config' );
		}

		
	}else{
		$html .=  $profiler->mark( ' no caching' );
	}




	$html .= '<div class="table-responsive"><table class="table table-striped table-condensed table-bordered "><thead><tr class="alert alert-success">
	<th class="text-center"><i class="fa fa-bug"></i></th>
	<th class="text-center">Debug</th>
	<th class="text-center"><i class="fa fa-clock-o" aria-hidden="true"></i></th>
	</tr></thead>';
	foreach ($msgs  as $key => $value) {
		
		$html .= '<tr><td>'.$value['func'].'</td><td>'.$value['msg'].'</td><td></td></tr>';
	}

	$html .= '</table></div>';



	echo $html;

}

