<?php
/**
* @Copyright Copyright (C) 2010 jtotal . All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* @link     	https://www.jtotal.org
**/

use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

// no direct access
defined('_JEXEC') or die;

	$module_id = $params->get( 'module_id','visual_menu_module_bs4' );

	//ANTON
	$clear_every = $params->get('clear_every','0');
	$css = $params->get('css','');
	$display_titles = $params->get('display_titles','1');
	$show_date = $params->get('show_date','0');
	$show_category = $params->get('show_category','0');
	$default_image = $params->get('default_image');
	$show_back = $params->get('show_back', '0');
	$show_introtext = $params->get('show_introtext', '0');


	//BOOTRAP
	$bs_lg = $params->get('bs_lg', '2');
	$bs_md = $params->get('bs_md', '3');
	$bs_sm = $params->get('bs_sm', '4');
	$bs_xs = $params->get('bs_xs', '6');

	$visual_menu_maxh_bs = $params->get('visual_menu_maxh_bs', '0');
	$bs_maxh_lg = $params->get('bs_maxh_lg', '');
	$bs_maxh_md = $params->get('bs_maxh_md', '');
	$bs_maxh_sm = $params->get('bs_maxh_sm', '');
	$bs_maxh_xs = $params->get('bs_maxh_xs', '');

	$vm_zoom_f = $params->get('vm_zoom', '1');


	/* TEST colums
		$col_bs_lg = 12/$bs_lg;
		$col_bs_md = 12/$bs_md;
		$col_bs_sm = 12/$bs_sm;
		$col_bs_xs = 12/$bs_xs;
	*/
?>

<style>
<?php
	echo $css;

	if($visual_menu_maxh_bs){
		if($bs_maxh_xs){
			echo '.menu_elements_wrapper.col-'.$bs_xs.' .vm_thumbnail div.vm_img_wrapper{
				max-height: '.$bs_maxh_xs.'px;
			}';
		}

		//768
		echo '@media (min-width: 768px){';
			if($bs_maxh_sm){
				echo '.menu_elements_wrapper.col-sm-'.$bs_sm.' .vm_thumbnail div.vm_img_wrapper{
					max-height: '.$bs_maxh_sm.'px;
				}';
			}
		echo '}';

		//992
		echo '@media (min-width: 992px){';
			if($bs_maxh_md){

				echo '.menu_elements_wrapper.col-md-'.$bs_md.' .vm_thumbnail div.vm_img_wrapper{
					max-height: '.$bs_maxh_md.'px;
				}';
			}
		echo '}';

		//1200
		echo '@media (min-width: 1200px){';
			if($bs_maxh_lg){
				
				echo '.menu_elements_wrapper.col-lg-'.$bs_lg.' .vm_thumbnail div.vm_img_wrapper{
					max-height: '.$bs_maxh_lg.'px;
				}';
			}
		echo '}';
	}


	if($vm_zoom_f != 1){
		$vm_zoom = $vm_zoom_f+100;
		$v_zoom_left = $vm_zoom_f/2;
		echo '.menu_elements_wrapper div.vm_img_wrapper img{
			    max-width: '.$vm_zoom.'%;
    			width: '.$vm_zoom.'%;
    			left: -'.$v_zoom_left.'%;
		}';
	}

?>



</style>

<?php
	//SAME Heights for all elements
	if($params->get('visual_menu_sameh_bs', '0')){
		$vm_sameh = ' vm_sameh';
	}else{
		$vm_sameh = ' ';
	}
?>

<div class="dx_menu_visual_wrapper">
	<div id="<?php echo $module_id;?>" class="dx_visual_module vm_bs <?php echo $vm_sameh;?>">
	<div class="vm_table">
	<?php
		if($show_back) : ?>
			
			<?php echo '<div class="menu_elements_wrapper showback col-lg-'.$bs_lg.' col-md-'.$bs_md.' col-sm-'.$bs_sm.' col-'.$bs_xs.'">';?>		
				<div class="vm_thumbnail">
					<a onClick="history.go(-1);return true;">
						<div class="showback_icon">
							<i class="fas fa-caret-square-left"></i>
						</div>
						<div class="vm_menu_title">
							<h3 class="vm_title">
									<?php echo Text::_('MOD_VISUAL_MENU_BACK'); ?>
							</h3>
						</div>
					</a>
				</div>
			</div>

		<?php endif; ?>
	

		<!--bucle principal-->
		<?php foreach ($list as $key => $item) : ?>
			
			<?php

				$keyplus = $key+1;

				$enlace = $item->link;
				if($use_article_url == 1 && ($item->urls != '')){
					$urls = json_decode($item->urls);
					if($urls->urla != '') $enlace = $urls->urla;
				}

				$enlace = OutputFilter::ampReplace(htmlspecialchars($enlace, ENT_COMPAT, 'UTF-8', false));
							
			
				
				echo '<div class=" menu_elements_wrapper col-lg-'.$bs_lg.' col-md-'.$bs_md.' col-sm-'.$bs_sm.' col-'.$bs_xs;
				

				if(isset($item->featured)){
					echo " vm_featured";
				}
				echo '">';

		

				if($item->active){
				    echo '<div class="vm_thumbnail  '.$item->active.' img_pos_'.$img_position.'">';

					//echo '<div class="vm_gradient vm_gradient_active"></div>';
					
					$vma = '<a class="vm_a '.$item->active.'">';
					$vma_img = '<a class="vm_picture_a '.$item->active.'">';

				}else{
					echo '<div class="vm_thumbnail img_pos_'.$img_position.'">';

					//echo '<div class="vm_gradient"></div>';

					//echo '<a class="vm_a" href="'.$enlace.'">';
					$vma = '<a class="vm_a" href="'.$enlace.'">';
					$vma_img = '<a class="vm_picture_a" href="'.$enlace.'">';
				}


				if(isset($item->displayImage)){?>
					<div class="vm_img_wrapper">
						<?php  echo $vma_img;?>
						<picture class="vm_picture">
							<?php 
								if(isset($item->displayImage['webp'])){
									if($item->displayImage['webp']){
										echo'<source srcset="'.$item->displayImage['path'].'.webp" type="image/webp" />';
									}
								}
								if(isset($item->displayImage['path'])) : ?>
									  <img class="vm_img" src="<?php echo $item->displayImage['path'].'.'.$item->displayImage['ext'];?>" alt="<?php echo $item->displayAlt;?>"/>
								<?php else : ?>
									 <img class="vm_img" src="<?php echo $item->displayImage;?>" alt="<?php echo $item->displayAlt;?>"/>
								<?php endif; ?>
						</picture>
						<?php  echo '</a>';?>
					</div>
				<?php }else{
					//default image
					echo '<div class="vm_img_wrapper">';
						if($default_image==NULL || $default_image=='-1'){
							echo '<img src="modules/mod_visual_menu/images/noimage.png" class="vm_img" alt="vm_noimage" />';	
						}else{
							
							echo '<img src="'.URI::base().'images/'.$default_image.'" class="vm_img" alt="'.$item->title.'" />';
						}
					echo '</div>';
				}

				echo '<div class="vm_menu_data">';
			
					echo '<div class="vm_menu_header">';

						?><?php 

						if($display_titles){

							echo '<div class="vm_menu_title">';
								echo '<h'.$vm_titles_h.' class="vm_title">';
									echo $vma.$item->title.'</a>';
								echo '</h'.$vm_titles_h.'>';
							echo '</div>';
						}
	 
						if($show_date){
						echo'<div class="vm_date"><small><i class="fa fa-calendar-o"></i> ';
							echo $item->displayDate;
							//var_dump($item);
							echo '</small></div>';
						}

						if($show_category){
						echo'<div class="vm_category"><span>';
							echo $item->category_title;
							//var_dump($item);
						echo '</span></div>';
						}
					echo '</div>';

					echo '<div class="vm_menu_body">';
						//INTROTEXT
						if($show_introtext){
							echo'<div class="vm_introtext"><span>';
								echo $item->displayIntrotext;
							echo '</span></div>';
						}
					echo '</div>';
					//READMORE
					echo '<div class="vm_menu_footer">';
						if($show_readmore && ($item->active!='active')){
							echo'<div class="vm_readmore">';

								echo'<a class="vm_readmore_a '.$readmore_class.'" target="'.$show_readmore_target.'" href="'.$enlace.'">';
									echo Text::_('MOD_VISUAL_MENU_READMORE');
								echo'</a>';

							echo '</div>';
						}

					echo '</div>';

				echo '</div>';

				//echo '</a>';



				?>
				
			</div>


		</div>
		<?php
		/*
		//clear every nth elements
			if($clear_every){
				if($keyplus % $clear_every){
					echo "</div>";
				}else{
					if($keyplus == 0){
						echo "</div>";
					}else{
						echo "</div>";
						echo '<div class="vm_clear"></div>';
						//echo "</td></tr><tr>";
					}
				}	
			}else{
				echo "</div>";
			} 
		*/
			?>
		<?php endforeach; ?>







		 <!--<div class="menu_elements_wrapper vm_tail"></div>-->
		</div>
	</div>
</div>
